/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is TableTools.
 *
 * The Initial Developer of the Original Code is
 * Mingyi Liu <mingyiliu@yahoo.com>
 * Portions created by the Initial Developer are Copyright (C) 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either of the GNU General Public License Version 2 or later (the "GPL"),
 * or the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

/* The sorting function inside this FF extension derives from my cross-browser html table sorting script
 hosted by on hotscripts.com at http://www.hotscripts.com/Detailed/57817.html
 and on my website (along with demo) at http://www.mingyi.org/other/ts_demo.html.
 That script can be used in your web pages to display in IE, and it is more
 powerful in some aspects
 The filter and copy functionalities are specifically developed for this extension
 although I'll probably put it into my JS too*/

function disablesortrows(val)
{
  if(!document.getElementById('ttools_no_sort_above_click').checked)
    disablesortrow(val);
  else
    disablesortrow(!val);
}

function disablesortrow(val)
{
  document.getElementById('ttools_table_head_row').disabled = val;
  document.getElementById('ttools_table_nohead_row').disabled = val;
}

function load_check(label, id)
{
  if(get_pref(label, 'bool')) document.getElementById(id).checked = true;
}

function load_menu(label, id)
{
  document.getElementById(id).value = get_pref(label, 'str');
}

function set_check(label, id)
{
  set_pref(label, document.getElementById(id).checked, 'bool');
}

function set_menu(label, id)
{
  set_pref(label, document.getElementById(id).value, 'str');
}

function load_prefs()
{
  load_check('tablesort.table_content_might_change', 'ttools_content_change');  
  load_check('tablesort.tell_me_time_consumption', 'ttools_time_used');  
  load_check('tablesort.default_sort_asc', 'ttools_sort_dir');  
  load_check('tablesort.alt_click', 'ttools_alt_click');
  load_check('tablesort.shift_click', 'ttools_shift_click');
  load_check('tablesort.shift_respect_filter', 'ttools_shift_respect_filter');
  load_check('tablesort.filter_delay_fill', 'ttools_filter_delay');
  load_check('tablesort.use_regex_filter', 'ttools_regex_filter');
  load_check('tablesort.no_sort_above_click', 'ttools_no_sort_above_click');
  load_menu('tablesort.default_date_style', 'ttools_date_style');
  load_menu('tablesort.preserve_style', 'ttools_preserve_style');
  load_menu('tablesort.minimum_sort_row', 'ttools_minimum_sort_row');
  load_menu('tablesort.table_head_row', 'ttools_table_head_row');
  load_menu('tablesort.table_nohead_row', 'ttools_table_nohead_row');
  load_menu('tablesort.qdown_char', 'ttools_copy_tab');
  load_menu('tablesort.edown_char', 'ttools_copy_html');
  load_menu('tablesort.zdown_char', 'ttools_copy_justified');
  disablesortrows(false);
}

function set_prefs()
{
  set_check('tablesort.table_content_might_change', 'ttools_content_change');  
  set_check('tablesort.tell_me_time_consumption', 'ttools_time_used');  
  set_check('tablesort.default_sort_asc', 'ttools_sort_dir');  
  set_check('tablesort.alt_click', 'ttools_alt_click');  
  set_check('tablesort.shift_click', 'ttools_shift_click');
  set_check('tablesort.shift_respect_filter', 'ttools_shift_respect_filter');
  set_check('tablesort.filter_delay_fill', 'ttools_filter_delay');
  set_check('tablesort.use_regex_filter', 'ttools_regex_filter');
  set_check('tablesort.no_sort_above_click', 'ttools_no_sort_above_click');
  set_menu('tablesort.default_date_style', 'ttools_date_style');
  set_menu('tablesort.preserve_style', 'ttools_preserve_style');
  set_menu('tablesort.minimum_sort_row', 'ttools_minimum_sort_row');
  set_menu('tablesort.table_head_row', 'ttools_table_head_row');
  set_menu('tablesort.table_nohead_row', 'ttools_table_nohead_row');
  set_menu('tablesort.qdown_char', 'ttools_copy_tab');
  set_menu('tablesort.edown_char', 'ttools_copy_html');
  set_menu('tablesort.zdown_char', 'ttools_copy_justified');
}
