/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is TableTools.
 *
 * The Initial Developer of the Original Code is
 * Mingyi Liu <mingyiliu@yahoo.com>
 * Portions created by the Initial Developer are Copyright (C) 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either of the GNU General Public License Version 2 or later (the "GPL"),
 * or the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */
 
/* The sorting function inside this FF extension derives from my cross-browser html table sorting script
 hosted by on hotscripts.com at http://www.hotscripts.com/Detailed/57817.html
 and on my website (along with demo) at http://www.mingyi.org/other/ts_demo.html.
 That script can be used in your web pages to display in IE, and it is more
 powerful in some aspects
 The filter and copy functionalities are specifically developed for this extension
 although I'll probably put it into my JS too*/

/* Acknowledgement: Various users tried to help with localization effort, like
   Roberto Cornice who translated this ext. into German, or Jean-Bernard Marcon
   who localized most parts of the 0.10 version and suggested that I use the help
   from http://www.babelzilla.org.  I will adopt this approach and thanks for
   all who helped (or will help at babelzilla.org)! */
   
// localizing strings first //
var gBundle = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService);
var strings = gBundle.createBundle("chrome://tabletools/locale/tabletools.properties");

var nostandard = strings.GetStringFromName("NoStandardTimeStamp");
var unsupported = strings.GetStringFromName("UnsupportedType");
var ittook = strings.GetStringFromName("ItTook") + ' ';
var sorting = ' ' + strings.GetStringFromName("SortTime");
var redrawing = ' ' + strings.GetStringFromName("RedrawingTime");
var sortcol = ' ' + strings.GetStringFromName("SortColTime");
var addoptions = ' ' + strings.GetStringFromName("AddOptionsTime");
var getdatarow = ' ' + strings.GetStringFromName("GetDataRow");
var filtertime = ' ' + strings.GetStringFromName("FilterTime");
var checkpadding = ' ' + strings.GetStringFromName("CheckPadding");
var dopadding = ' ' + strings.GetStringFromName("DoPadding");

var ml_tsort = {

  init : function()
  {
    if(document.getElementById("contentAreaContextMenu") != null)
    {
      document.getElementById("contentAreaContextMenu").addEventListener("popupshowing", ml_tsort.menuitem_showhide, false);
    }
  },
  
  set_vars : function(event) 
  {
    var ele = event.target;
    ml_tsort.clicked_table = ml_tsort.getParent(ele,'TABLE');
    ml_tsort.clicked_td = ml_tsort.getParent(ele,'TD') || ml_tsort.getParent(ele,'TH');
    ml_tsort.clicked_tr = ml_tsort.getParent(ele,'TR');

    if(!ml_tsort.clicked_table || ml_tsort.clicked_table.rows.length < 1 || !ml_tsort.clicked_td) return;
    ml_tsort.table_content_might_change = get_pref('tablesort.table_content_might_change', 'bool'); 
    ml_tsort.preserve_style = get_pref('tablesort.preserve_style', 'str'); 
    ml_tsort.tell_me_time_consumption = get_pref('tablesort.tell_me_time_consumption', 'bool'); 
    ml_tsort.default_date_style = get_pref('tablesort.default_date_style', 'str');
    ml_tsort.default_sort_asc = get_pref('tablesort.default_sort_asc', 'bool');
    ml_tsort.alt_click = get_pref('tablesort.alt_click', 'bool');
    ml_tsort.shift_click = get_pref('tablesort.shift_click', 'bool');
    ml_tsort.shift_respect_filter = get_pref('tablesort.shift_respect_filter', 'bool');
    ml_tsort.filter_delay_fill = get_pref('tablesort.filter_delay_fill', 'bool');
    ml_tsort.use_regex_filter = get_pref('tablesort.use_regex_filter', 'bool');
    ml_tsort.no_sort_above_click = get_pref('tablesort.no_sort_above_click', 'bool');
    ml_tsort.minimum_sort_row = parseInt(get_pref('tablesort.minimum_sort_row', 'str'));
    if(isNaN(ml_tsort.minimum_sort_row) || !ml_tsort.minimum_sort_row) ml_tsort.minimum_sort_row = 4;
    ml_tsort.table_head_row = parseInt(get_pref('tablesort.table_head_row', 'str'));
    if(isNaN(ml_tsort.table_head_row) || ml_tsort.table_head_row < 0) ml_tsort.table_head_row = 0;
    ml_tsort.table_nohead_row = parseInt(get_pref('tablesort.table_nohead_row', 'str'));
    if(isNaN(ml_tsort.table_nohead_row) || ml_tsort.table_nohead_row < 0) ml_tsort.table_nohead_row = 1;

    // don't change skiprows if user is clicking on filters!
    if(ml_tsort.clicked_tr && ml_tsort.clicked_tr.getAttribute('filterRow') != 'filterRow')
    {
      if(ml_tsort.no_sort_above_click)
      {
        ml_tsort.skiprows = 0;
        if(ml_tsort.clicked_table && ml_tsort.clicked_table.rows.length >= ml_tsort.minimum_sort_row)
        {
          for (var j=0; j < ml_tsort.clicked_table.rows.length; j++)
          {
            if(ml_tsort.clicked_table.rows[j] == ml_tsort.clicked_tr) break;
            if(ml_tsort.clicked_table.rows[j].parentNode.tagName.toLowerCase() == 'tbody')
              ml_tsort.skiprows++;
          }
        }
      }
      else
      {
        ml_tsort.skiprows = (ml_tsort.table_has_header(ml_tsort.clicked_table))? ml_tsort.table_head_row : ml_tsort.table_nohead_row;
        // below coded added by Javier Lopez
        var mrs=1;
        var fri = (ml_tfilter)?ml_tfilter.find_filter_row(ml_tsort.clicked_table):-1;
        var cells = ml_tsort.clicked_table.rows[fri + 1].cells;
        for(var i=0;i<cells.length;i++)
        {
          var rs = parseInt(cells[i].getAttribute("rowspan"),10);
          if(rs>mrs) mrs=rs;
        }
        ml_tsort.skiprows += mrs-1;
        // end code by Javier Lopez
      }
    }

    if (event.ctrlKey)
    {
      var filtered_only = false;
      if(ml_tsort.shift_respect_filter && event.shiftKey) filtered_only = true;
      if(ml_keyrecorder.q_down) ml_tcopy.copy({type:'tab', filtered_only:filtered_only});
      else if(ml_keyrecorder.e_down) ml_tcopy.copy({type:'html', filtered_only:filtered_only});
      else if(ml_keyrecorder.z_down) ml_tcopy.copy({type:'txt', filtered_only:filtered_only});
      else if(event.shiftKey && ml_tsort.shift_click) ml_tfilter.showhide_filter();
      else if(event.altKey && ml_tsort.alt_click) ml_tsort.resort_table();
    }

  },
  
  menuitem_showhide : function() 
  {
    if (ml_tsort.clicked_td == null)
    {
      document.getElementById("ttools_menu").hidden = true;
      document.getElementById("ttools_othermenu").hidden = true;
    }
    else
    {
      document.getElementById("ttools_othermenu").hidden = false;
      if(ml_tsort.clicked_table && ml_tsort.clicked_table.rows.length >= ml_tsort.minimum_sort_row)
      {
        document.getElementById("ttools_menu").hidden = false;
        document.getElementById("ttools_othermenu_filter").hidden = false;
        document.getElementById("ttools_othermenu_regexfilter").hidden = false;
      }
      else
      {
        document.getElementById("ttools_menu").hidden = true;
        document.getElementById("ttools_othermenu_filter").hidden = true;
        document.getElementById("ttools_othermenu_regexfilter").hidden = true;
      }
    }
  },
  
  getParent : function(el, pTagName) 
  {
    if (el == null) return null;
    else if (el.nodeType == 1 && el.tagName.toLowerCase() == pTagName.toLowerCase())  // Gecko bug, supposed to be uppercase
      return el;
    else
      return this.getParent(el.parentNode, pTagName);
  },

  getInnerText : function(el) 
  {
    if (typeof el == "string") return el;
    if (typeof el == "undefined") { return el };
    if (el.innerText) return el.innerText;  //Not needed but it is faster
    var str = " ";
    
    var cs = el.childNodes;
    var l = cs.length;
    for (var i = 0; i < l; i++) {
      switch (cs[i].nodeType) {
        case 1: //ELEMENT_NODE
          str += this.getInnerText(cs[i]);
          break;
        case 3:  //TEXT_NODE
          str += cs[i].nodeValue;
          break;
      }
    }
    return str;
  },

  match_date_format : function(value, format)
  {
    format = format.replace(/\//g, '[-. \\/]');
    this.set_date_array(format);
    if(!isNaN(this.convert_date(value))) return true;
    return false;
  },
  
  get_sortfn : function(warn_type, user_type)
  {
    var sortfn = this.sort_caseinsensitive;
    var table = this.clicked_table;
    var td = this.clicked_td;
    var column = this.sort_column_index;
    if(!table || table.rows.length < ml_tsort.minimum_sort_row || !td) return sortfn;
    var filter_row_index = ml_tfilter.find_filter_row(table);
    var type = user_type || table.rows[filter_row_index+1].cells[column].getAttribute("ts_sorttype");
    this.replace_pattern = '';

    // find first non-empty data cell
    var itm;
    for(var rowcount = 0, i = filter_row_index+1; i < table.rows.length; i++)
    {
      if(rowcount++ < ml_tsort.skiprows) continue; // skip head rows
      var t = table.rows[i].parentNode.tagName.toLowerCase();
      if(t == 'tbody' && table.rows[i].cells.length >= column + 1)
      {
        itm = this.getInnerText(table.rows[i].cells[column]);
        if(itm.match(/\S/)) break;
      }
    }
    if(i == table.rows.length) return sortfn;
    // Work out a type for the column if necessary
    if(!type || (!user_type && this.table_content_might_change)) // if table might change and the type's not set by user at this moment, then we can't rely on previously set type
    {
      // let's try really hard to check dates separated by - or / or .
      if (this.default_date_style == 'euro' && this.match_date_format(table.rows[i], 'D/M/Y'))
      { sortfn = this.sort_date; type = 'euro_date' }
      else if (this.match_date_format(table.rows[i], 'M/D/Y'))
      { sortfn = this.sort_date; type = 'date' }
      else if (itm.match(/^[〥$]/))
      { sortfn = this.sort_currency; type = 'money' }
      else if (itm.match(/^\d{1,3}(\.\d{1,3}){3}$/))
      { sortfn = this.sort_ip; type = 'ip' }
      else if (itm.match(/^\s*[+-]?\s*[0-9,]+(?:\.[0-9]+)?(?:\s*[eE]\s*[+-]?\s*\d+)?\s*$/))
      { sortfn = this.sort_numeric; type = 'number' }
    }
    else if(type == 'string') sortfn = this.sort_caseinsensitive;
    else if(type == 'date')
    {
      if(this.match_date_format(table.rows[i], 'M/D/Y')) sortfn = this.sort_date;
      else if(warn_type) alert(nostandard);
    }
    else if(type == 'euro_date')
    {
      if(this.match_date_format(table.rows[i], 'D/M/Y')) sortfn = this.sort_date;
      else if(warn_type) alert(nostandard);
    }
    else if(type == 'year_month_date')
    {
      if(this.match_date_format(table.rows[i], 'Y/M/D')) sortfn = this.sort_date;
      else if(warn_type) alert(nostandard);
    }
    else if(type == 'year_date_month')
    {
      if(this.match_date_format(table.rows[i], 'Y/D/M')) sortfn = this.sort_date;
      else if(warn_type) alert(nostandard);
    }
    else if(type == 'other_date')
    {
      this.set_date_array(td.getAttribute("ts_date_format").replace(/\//g, '[-. \\/]'));
      sortfn = this.sort_date;
    }
    else if(type == 'number') sortfn = this.sort_numeric;
    else if(type == 'ip') sortfn = this.sort_ip;
    else if(type == 'money') sortfn = this.sort_currency;
//       else if(type == 'custom') sortfn = function(aa,bb) { a = this.getInnerText(aa.cells[this.sort_column_index]); b = this.getInnerText(bb.cells[this.sort_column_index]); eval(td.getAttribute("ts_sortfn")) }; // the coding here is shorter but interestingly it's also slower
    else if(type == 'custom') { this.custom_code = td.getAttribute("ts_sortfn"); sortfn = this.custom_sortfn }
    else if(warn_type) { alert(unsupported); }
    table.rows[filter_row_index+1].cells[column].setAttribute("ts_sorttype", type); // store type for the convenience of both program and user (no need to use context menu to set type again)
    return sortfn;
  },
  
  table_has_header : function(table)
  {
    if(table.tHead && table.tHead.rows.length > 0)
    {
      if(table.tHead.rows.length == 1 && table.tHead.rows[0].getAttribute('filterRow') == 'filterRow')
        return false;
      return true;
    }
    return false;
  },
  
  resort_table : function(type)
  {
    var td = this.clicked_td;
    if(td == null) return;
    var column = td.cellIndex;
    var table = this.clicked_table;
    this.sort_column_index = column;
    if(table == null || table.rows.length < ml_tsort.minimum_sort_row) return;
    var filter_row_index = ml_tfilter.find_filter_row(table);

    // set the data rows
    var newRows = new Array();
    var headcount = filter_row_index+1;
    for (var i=0,j=filter_row_index+1,rowcount=0;j<table.rows.length;j++)
    {
      var t = table.rows[j].parentNode.tagName.toLowerCase();
      if(t == 'tbody')
      {
        if(rowcount++ < ml_tsort.skiprows) continue;
        else if(table.rows[j].cells.length >= column + 1) newRows[i++] = table.rows[j];
      }
      else if(t == 'thead') headcount++;
    }
    if(newRows.length == 0) return;
    var time2 = new Date();
    // sort table, first check if we really need to sort - let's do a lot just to save a little time, if possible at all. ;)
    var lastSortCell = table.getAttribute("ts_sortcell") || 0;
    lastSortCell--; // the processing is used for IE, which treats no attribute as 0, while FF treats 0 as still true.
    var lastSkipRows = table.getAttribute("ts_skiprows") || -1;
    var lastSortType = table.rows[filter_row_index+1].cells[column].getAttribute("ts_sorttype");
    var sortingSameColumnAndTypeAndRow = (table == this.last_sorted_table && column == lastSortCell
      && (!type || type == lastSortType) && (!ml_tsort.no_sort_above_click || ml_tsort.skiprows == lastSkipRows));
    table.setAttribute('ts_skiprows',ml_tsort.skiprows);
    if(type == 'default') // auto-detect type again, so forget the previously set type
    {
      table.rows[filter_row_index+1].cells[column].removeAttribute("ts_sorttype");
      type = null;
    }
    else if(type != null) table.rows[filter_row_index+1].cells[column].setAttribute("ts_sorttype", type);
    var lastSortDir = (sortingSameColumnAndTypeAndRow)? table.getAttribute("ts_sortdir") : ((this.default_sort_asc)? 'desc' : 'asc');
    if(!this.table_content_might_change && sortingSameColumnAndTypeAndRow)
      newRows.reverse();
    else
    {
      var sortfn = this.get_sortfn(true, type);
      table.setAttribute("ts_sortcell", column+1);
      newRows.sort(sortfn);
      if (lastSortDir == 'asc') newRows.reverse();
    }
    if (lastSortDir == 'desc') table.setAttribute('ts_sortdir','asc');
    else table.setAttribute('ts_sortdir','desc');
    this.last_sorted_table = table;
       
    var time3 = new Date();
    
    // update the table
    if(this.preserve_style == 'row')
    {
      var tmp = new Array(newRows.length);
      for (var i = 0; i < newRows.length; i++) tmp[i] = newRows[i].innerHTML;
      for (var i = 0; i < newRows.length; i++) table.rows[i+headcount+ml_tsort.skiprows].innerHTML = tmp[i];
    }
    else if(this.preserve_style == 'cell')
    {
      var tmp = new Array(newRows.length);
      for (var i = 0; i < newRows.length; i++)
        for (var j = 0; j < newRows[i].cells.length; j++)
        {
          if(!tmp[i]) tmp[i] = new Array(newRows[i].cells.length);
          tmp[i][j] = newRows[i].cells[j].innerHTML;
        }
      for (var i = 0; i < newRows.length; i++)
        for (var j = 0; j < newRows[i].cells.length; j++)
          table.rows[i+headcount+ml_tsort.skiprows].cells[j].innerHTML = tmp[i][j];
    }
    else
    {
      for (var i=0;i<newRows.length;i++) // We appendChild rows that already exist to the tbody, so it moves them rather than creating new ones
        table.tBodies[0].appendChild(newRows[i]);
    }
    
    var time4 = new Date();
    if(this.tell_me_time_consumption)
    {
      alert(ittook + this.diff_time(time3, time2) + sorting);
      alert(ittook + this.diff_time(time4, time3) + redrawing);
    }
  },
  
  diff_time : function(time2, time1) 
  {
    return (time2.getTime() - time1.getTime())/1000;
  },
  
  // Mingyi Note: it seems ridiculous to do so much processing for
  // customizable date conversion, should try to find a zbetter way
  // of doing it.
  set_date_array : function(f) 
  {
    var tmp = [['D', f.indexOf('D')], ['M', f.indexOf('M')], ['Y', f.indexOf('Y')]];
    tmp.sort(function(a,b){ return a[1] - b[1]});
    this.date_order_array = new Array(3);
    for(var i = 0; i < 3; i++) this.date_order_array[tmp[i][0]] = '$' + (i + 2);
    this.replace_pattern = f.replace(/[DMY]([^DMY]+)[DMY]([^DMY]+)[DMY]/, '^(.*?)(\\d+)$1(\\d+)$2(\\d+)(.*)$');
  },
  
  process_year : function(y) 
  {
    var tmp = parseInt(y);
    if(tmp < 32) return '20' + y;
    else if(tmp < 100) return '19' + y;
    else return y;
  },

  // convert to MM/DD/YYYY (or M/D/YYYY) format
  convert_date : function(a) 
  {
    if(!a) return 0;
    var aa = this.getInnerText(a.cells[this.sort_column_index]);
    if(!aa) return 0;
    var re = 'RegExp.$1+RegExp.'+this.date_order_array['M']+'+\'/\'+RegExp.'+this.date_order_array['D']+'+\'/\'+this.process_year(RegExp.'+this.date_order_array['Y']+')+RegExp.$5';
    var code = 'if(aa.match(/'+this.replace_pattern+'/)) (' + re + '); else aa;';
    return Date.parse(eval(code));
  },
  
  sort_date : function(a,b) 
  {
    var aa, bb;
    // basically I have to do the conversion due to the potential usage of double digit years
    aa = ml_tsort.convert_date(a);
    if(isNaN(aa)) aa = Date.parse(ml_tsort.getInnerText(a.cells[ml_tsort.sort_column_index]));
    bb = ml_tsort.convert_date(b);
    if(isNaN(bb)) bb = Date.parse(ml_tsort.getInnerText(b.cells[ml_tsort.sort_column_index]));
    if(isNaN(aa)) aa = 0;
    if(isNaN(bb)) bb = 0;
    return aa - bb;
  },
  
  // assume no scientific number in currency (if assumption incorrect, just use
  // same code for this.sort_numeric will do)
  sort_currency : function(a,b) 
  { 
    return ml_tsort.sort_num(ml_tsort.getInnerText(a.cells[ml_tsort.sort_column_index]).replace(/[^-0-9.+]/g,''),
                       ml_tsort.getInnerText(b.cells[ml_tsort.sort_column_index]).replace(/[^-0-9.+]/g,''));
  },
  
  // let's allow scientific notation but also be strict on number format
  sort_num : function(a, b) 
  {
    var aa, bb;
    if(!isNaN(a)) aa = a;
    else if(a && a.match(/^[^0-9.+-]*([+-]?\s*[0-9]+(?:\.[0-9]+)?(?:\s*[eE]\s*[+-]?\s*\d+)?)/))
      aa = parseFloat(RegExp.$1.replace(/\s+/g, ''));
    else aa = 0;
    if(!isNaN(b)) bb = b;
    else if(b && b.match(/^[^0-9.+-]*([+-]?\s*[0-9]+(?:\.[0-9]+)?(?:\s*[eE]\s*[+-]?\s*\d+)?)/))
      bb = parseFloat(RegExp.$1.replace(/\s+/g, ''));
    else bb = 0;
    return aa - bb;
  },
  
  sort_numeric : function(a,b) 
  {
    return ml_tsort.sort_num(ml_tsort.getInnerText(a.cells[ml_tsort.sort_column_index]).replace(/,/g,''),
                       ml_tsort.getInnerText(b.cells[ml_tsort.sort_column_index]).replace(/,/g,'')); 
  },
  
  sort_ip : function(a,b) 
  {
    var aa = ml_tsort.getInnerText(a.cells[ml_tsort.sort_column_index]).split('.');
    var bb = ml_tsort.getInnerText(b.cells[ml_tsort.sort_column_index]).split('.');
    return ml_tsort.sort_num(aa[0], bb[0]) || ml_tsort.sort_num(aa[1], bb[1]) || 
           ml_tsort.sort_num(aa[2], bb[2]) || ml_tsort.sort_num(aa[3], bb[3]);
  },
   
  sort_caseinsensitive : function(a,b) 
  {
    var aa = ml_tsort.getInnerText(a.cells[ml_tsort.sort_column_index]).toLowerCase();
    var bb = ml_tsort.getInnerText(b.cells[ml_tsort.sort_column_index]).toLowerCase();
    if (aa==bb) return 0;
    if (aa<bb) return -1;
    return 1;
  },
  
  custom_sortfn : function(aa,bb) 
  {
    var a = ml_tsort.getInnerText(aa.cells[ml_tsort.sort_column_index]);
    var b = ml_tsort.getInnerText(bb.cells[ml_tsort.sort_column_index]);
    return eval(ml_tsort.custom_code);
  }
};

function get_pref(key, type)
{
  var p = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
  if(!type || type == 'string' || type == 'str') return p.getCharPref(key);
  if(type == 'boolean' || type == 'bool') return p.getBoolPref(key);  
}

function set_pref(key, value, type)
{
  var p = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
  if(!type || type == 'string' || type == 'str') p.setCharPref(key, value);
  if(type == 'boolean' || type == 'bool') p.setBoolPref(key, value);
}

var ml_tfilter = {
  need_to_fill_filters: true,
  
  show_all : function(table)
  {
    for(var i = 0; i < table.rows.length; i++)
    {
      var row = table.rows[i];
      if(row.style.display == 'none') // if the table author already hid some options before we filter, we probably should respect that by setting attribute on rows we filtered, and do not filter/show those already hidden. But one could always view the html or selection source to see hidden rows, so let's just stay lazy and not deal with it now
        row.style.display = '';
      for(var j = 0; j < row.cells.length; j++) // might consider record last filtered column (but pay attention to search all columns option)
        row.cells[j].removeAttribute('ml_tt_h');
    }
  },
  
  showhide_regex_filter : function()
  {
    ml_tsort.use_regex_filter = true;
    this.showhide_filter();
  },

  showhide_select_filter : function()
  {
    ml_tsort.use_regex_filter = false;
    this.showhide_filter();
  },

  showhide_filter : function()
  {
    var table = ml_tsort.clicked_table;
    if(!table || table.rows.length < ml_tsort.minimum_sort_row) return;
    if(table.getAttribute('ts_filter') == 'shown')
    {
      for(var i = 0; i < table.rows.length; i++)
        if(table.rows[i].getAttribute('filterRow') == 'filterRow') table.deleteRow(i);
      ml_tfilter.show_all(table);
      table.removeAttribute("ts_filter");
    }
    else
    {
      var thead, colnum = table.rows[ml_tsort.skiprows].cells.length;
      if(table.tHead) thead = table.tHead;
      else
      {
        thead = content.document.createElement("thead");
        table.appendChild(thead);
      }
      var row = content.document.createElement("tr");
      thead.appendChild(row);
      row.setAttribute('filterRow', 'filterRow');
      for(var i = 0; i < colnum; i++)
      {
        var cell = content.document.createElement("td");
        row.appendChild(cell);
        if(ml_tsort.use_regex_filter)
        {
          var input = content.document.createElement("input");
          input.type = "text";
          input.size = 3;
          input.addEventListener("change", this.do_filter, false);
          cell.appendChild(input);
        }
        else
        {
          var select = content.document.createElement("select");
          select.options.add(new Option('(all)', '(all)'));
          select.addEventListener("mouseup", this.set_invert, false);
          select.addEventListener("change", this.do_filter, false);
          select.addEventListener("focus", this.fill_filter, false);
          cell.appendChild(select);
        }
      }
      if(!ml_tsort.filter_delay_fill) this.populate_filter(table, -1);
      table.setAttribute('ts_filter', 'shown');
    }
  },
  
  set_invert : function(event)
  {
    if(event.ctrlKey) ml_tsort.invert_filter = true;
    else ml_tsort.invert_filter = false;
  },

  fill_filter : function(event)
  {
    if(!ml_tsort.filter_delay_fill) return;
    var ele = event.target;
    var table = ml_tsort.getParent(ele,'TABLE');
    var td = ml_tsort.getParent(ele,'TH') || ml_tsort.getParent(ele,'TD');
    if(!table || table.rows.length < ml_tsort.minimum_sort_row || !td) return;
    ml_tfilter.populate_filter(table, td.cellIndex);
  },
  
  populate_filter : function(table, column)
  {
    if(ml_tsort.use_regex_filter) return;
    var newRows = new Array(), filter_row_index = ml_tfilter.find_filter_row(table);
    var time = new Date();
    for(var rowcount = 0, j = filter_row_index + 1; j < table.rows.length; j++)
    {
      if(rowcount++ < ml_tsort.skiprows) continue;
      var row = table.rows[j];
      var t = row.parentNode.tagName.toLowerCase();
      if(t == 'tbody' && row.style.display != 'none') newRows.push(row);
    }
    if(newRows.length == 0) return; // useful for invert filter causing table to become empty, then let's keep the current menu items
    for(var i = 0; i < table.rows[filter_row_index].cells.length; i++)
    {
      if(ml_tsort.filter_delay_fill && column > -1 && i != column) continue;
      var time1 = new Date();
      ml_tsort.sort_column_index = i;
      // we need to guess type of column before sorting them correctly (well, if we missed the type, it's still OK)
      var sortfn = ml_tsort.get_sortfn(false);
      newRows.sort(sortfn);
      var time2 = new Date();

      // add the values now
      var select = table.rows[filter_row_index].cells[i].firstChild;
      var filter = select.selectedIndex;
      select.options.length = 1;
      for(var row, j = 0; j < newRows.length; j++)
      {
        if(j == 0 || sortfn(row, newRows[j]) != 0)
        {
          row = newRows[j];
          var val = ml_tsort.getInnerText(row.cells[i]);
          select.options.add(new Option(val, val));
        }
      }
      if(filter > 0) select.options[1].selected = true; // this is necessary since setting select.value = filter fails when the same-valued time stamps are different string, for example
      var time3 = new Date();
      if(ml_tsort.tell_me_time_consumption)
      {
        alert(ittook + ml_tsort.diff_time(time2, time1) + sortcol + i);
        alert(ittook + ml_tsort.diff_time(time3, time2) + addoptions + i);
      }
    }
    var time4 = new Date();
    if(ml_tsort.tell_me_time_consumption)
    {
      alert(ittook + ml_tsort.diff_time(time1, time) + getdatarow);
    }
    ml_tfilter.need_to_fill_filters = false;
  },

  find_filter_row : function(table)
  {
    for(var i = 0; i < table.rows.length; i++)
      if(table.rows[i].getAttribute('filterRow') == 'filterRow') return i;
    return -1;
  },
  
  do_filter : function(event)
  {
    var ele = event.target;
    var table = ml_tsort.getParent(ele,'TABLE');
    var td = ml_tsort.getParent(ele,'TH') || ml_tsort.getParent(ele,'TD');
    if(!table || table.rows.length < ml_tsort.minimum_sort_row || !td) return;
    var sortfn, row, column = td.cellIndex, filter_row_index = ml_tfilter.find_filter_row(table);

    var time = new Date();

    // now one could store all filtering columns and re-apply all of them every time one of
    // the filters changes, but that's just quite inefficient, particularly with large tables
    // since most data tables are not changed on the fly, the following way should be much faster
    // also much simpler to code (if table does change on-the-fly, then user should show/hide filters again)
    var filtered_value = table.rows[filter_row_index].cells[column].firstChild.value;
    ml_tsort.use_regex_filter = table.rows[filter_row_index].cells[column].firstChild.tagName.toLowerCase() == 'input';

    // set some values for the regex_filters
    var search_all_columns = false;
    if(ml_tsort.use_regex_filter)
    {
      if(filtered_value.match(/^:INV:(.*)/))
      {
        ml_tsort.invert_filter = true;
        filtered_value = RegExp.$1;
      }
      else if(filtered_value.match(/^:ALL:(.*)/))
      {
        filtered_value = RegExp.$1;
        search_all_columns = true;
        ml_tsort.invert_filter = false;
      }
      else if(filtered_value.match(/^:INVALL:(.*)/))
      {
        filtered_value = RegExp.$1;
        ml_tsort.invert_filter = true;
        search_all_columns = true;
      }
      else
      {
        ml_tsort.invert_filter = false;
        search_all_columns = false;
      }
    }

    if(ml_tsort.invert_filter) table.rows[filter_row_index].cells[column].firstChild.style.background = 'yellow';
    else table.rows[filter_row_index].cells[column].firstChild.style.background = '';
    if(filtered_value != '(all)' && !ml_tsort.use_regex_filter)
    {
      // let's find the row containing the filter value so that we could call the existing comparison functions (the only easy way to get around an IE problem)
      for(var rowcount = 0, i = filter_row_index + 1; i < table.rows.length; i++)
      {
        if(rowcount++ < ml_tsort.skiprows) continue; // skip head rows
        row = table.rows[i];
        var t = row.parentNode.tagName.toLowerCase();
        if(t == 'tbody' && ml_tsort.getInnerText(row.cells[column]) == filtered_value) break;
      }
      ml_tsort.sort_column_index = column;
      ml_tsort.clicked_table = table;
      ml_tsort.clicked_td = td;
      sortfn = ml_tsort.get_sortfn(false);
    }
    // now the real filtering
    for(var rowcount = 0, i = filter_row_index + 1; i < table.rows.length; i++)
    {
      if(rowcount++ < ml_tsort.skiprows) continue; // skip head rows
      var row1 = table.rows[i];
      var t = row1.parentNode.tagName.toLowerCase();
      if(t == 'tbody')
      {
        var has_hidden = false;
        var found = false;
        var re = new RegExp(filtered_value, "i");
        for(var j = 0; j < row1.cells.length; j++)
        {
          if(j == column)
          {
            if(ml_tsort.use_regex_filter)
            {
              var cellval = ml_tsort.getInnerText(row1.cells[j]);
              if(ml_tsort.invert_filter)
              {
                if(filtered_value == '' || re.test(cellval))
                {
                  if(!search_all_columns) has_hidden = true;
                  row1.cells[j].setAttribute('ml_tt_h', 'y');
                }
                else { found = true; row1.cells[j].removeAttribute('ml_tt_h'); }
              }
              else
              {
                if(filtered_value == '' || re.test(cellval)) { found = true; row1.cells[j].removeAttribute('ml_tt_h'); }
                else
                {
                  if(!search_all_columns) has_hidden = true;
                  row1.cells[j].setAttribute('ml_tt_h', 'y');
                }
              }
            }
            else
            {
              if(ml_tsort.invert_filter)
              {
                if(filtered_value == '(all)' || sortfn(row, row1) == 0) { has_hidden = true; row1.cells[j].setAttribute('ml_tt_h', 'y') }
                else row1.cells[j].removeAttribute('ml_tt_h');
              }
              else
              {
                if(filtered_value == '(all)' || sortfn(row, row1) == 0) row1.cells[j].removeAttribute('ml_tt_h');
                else { has_hidden = true; row1.cells[j].setAttribute('ml_tt_h', 'y') }
              }
            }
          }
          else
          {
            if(row1.cells[j].getAttribute('ml_tt_h')) has_hidden = true;
            if(ml_tsort.use_regex_filter && search_all_columns)
            {
              var cellval = ml_tsort.getInnerText(row1.cells[j]);
              // when invert_filter and search_all_columns are both true we have to use a different logic
              if(filtered_value == '' || re.test(cellval))
              {
                if(ml_tsort.invert_filter) { has_hidden = true; row1.cells[column].setAttribute('ml_tt_h', 'y') }
                else found = true;
              }
            }
          }
        }
        if(found) row1.cells[column].removeAttribute('ml_tt_h');
        row1.style.display = (has_hidden || (ml_tsort.use_regex_filter && !found))? 'none' : '';
      }
    }
    var time1 = new Date();
    if(ml_tsort.tell_me_time_consumption)
    {
      alert(ittook + ml_tsort.diff_time(time1, time) + filtertime);
    }
    ml_tfilter.need_to_fill_filters = true;
    if(!ml_tsort.filter_delay_fill || filtered_value == '(all)') ml_tfilter.populate_filter(table, column);
  }
};

/**************************************
* Jonas Raoni Soares Silva code
* http://www.joninhas.ath.cx
**************************************/

String.prototype.pad = function(l, s, t){ //v1.0
    return s || (s = " "), (l -= this.length) > 0 ? (s = new Array(Math.ceil(l / s.length)
        + 1).join(s)).substr(0, t = !t ? l : t == 1 ? 0 : Math.ceil(l / 2))
        + this + s.substr(0, l - t) : this;
};

/**************************************
* End Jonas Raoni Soares Silva Code
**************************************/

function ml_add2clipboard(copytext)
{
  const gClipboardHelper = Components.classes["@mozilla.org/widget/clipboardhelper;1"].
                                  getService(Components.interfaces.nsIClipboardHelper);
  gClipboardHelper.copyString(copytext);
}

function ml_trim(text)
{
  if(!text) return text;
  var tmp = text.replace(/^\s+/, '');
//   tmp = tmp.replace(/[\n\r]/g, ' '); // wonder if \s+ is slower although better
  tmp = tmp.replace(/\s+/g, ' '); // wonder if \s+ is slower although better
  return tmp.replace(/\s+$/, '');
}

// inspired by discussion board to get around the problem of firefox
// lacking the convenient outerHTML property
function ml_outerHTML(node)
{
  if(!node.cloneNode) return '';
  var d = content.document.createElement('div');
  d.appendChild(node.cloneNode(true));
  return d.innerHTML;
}

var ml_tcopy = {
  copy : function(opt)
  {
    var type = opt.type;
    var filtered_only = opt.filtered_only;
    var select_type = opt.select_type; // column, cell, whole table (default)
    var table = ml_tsort.clicked_table;
    if(!table) return;
    var copytext = '';
    if(type == 'html')
    {
      if(!table.cloneNode) return;
      var table1 = table.cloneNode(true);
      var len = table1.rows.length;
      for(var i = 0; i < len; i++)
      {
        var row = table1.rows[i];
        if(row.getAttribute('filterRow') == 'filterRow' || (filtered_only && row.style.display == 'none'))
        {
          table1.deleteRow(i);
          i--;
          len--;
        }
      }
      copytext += ml_outerHTML(table1);
    }
    else if(type == 'tab')
    {
      for(var i = 0; i < table.rows.length; i++)
      {
        var row = table.rows[i];
        if(row.getAttribute('filterRow') == 'filterRow' || (filtered_only && row.style.display == 'none')) continue;
        for(var j = 0; j < row.cells.length; j++)
          copytext += ((j == 0)? '' : '\t') + ml_trim(ml_tsort.getInnerText(row.cells[j]));
        copytext += '\n';
      }
    }
    else if(type == 'txt')
    {
      var maxcol = 0, maxwid = new Array(), data = new Array();
      // find out how much we need to pad
      var time2 = new Date();
      for(var i = 0, k = 0; i < table.rows.length; i++)
      {
        var row = table.rows[i];
        if(row.getAttribute('filterRow') == 'filterRow' || (filtered_only && row.style.display == 'none')) continue;
        if(row.cells)
        {
          data[k] = new Array();
          if(row.cells.length > maxcol) maxcol = row.cells.length;
          for(var j = 0; j < row.cells.length; j++)
          {
            var txt = ml_trim(ml_tsort.getInnerText(row.cells[j]));
            if(i == 0 || maxwid.length <= j || maxwid[j] < txt.length) maxwid[j] = txt.length;
            data[k][j] = txt; // store data to make the next step significantly faster
          }
          k++;
        }
      }
      var time3 = new Date();
      var copytext = '';
      for(var i = 0; i < data.length; i++)
      {
        for(var j = 0; j < maxcol; j++)
        {
          var txt = (j >= data[i].length)? '' : data[i][j];
          copytext += ((!j)? '' : '\t') + txt.pad(maxwid[j], ' ', 1);
        }
        copytext += '\n';
      }
      var time4 = new Date();
      if(ml_tsort.tell_me_time_consumption)
      {
        alert(ittook + ml_tsort.diff_time(time3, time2) + checkpadding);
        alert(ittook + ml_tsort.diff_time(time4, time3) + dopadding);
      }
    }
    ml_add2clipboard(copytext);
  }
};

var ml_keyrecorder = {
  q_char: 'Q',
  e_char: 'E',
  z_char: 'Z',
  q_down: false,
  e_down: false,
  z_down: false,
  set_vars: function()
  {
    ml_keyrecorder.q_char = get_pref('tablesort.qdown_char', 'str');
    ml_keyrecorder.e_char = get_pref('tablesort.edown_char', 'str');
    ml_keyrecorder.z_char = get_pref('tablesort.zdown_char', 'str');
  },
  set_key: function(event)
  {
    ml_keyrecorder.set_vars();
    var code = event.charCode || event.keyCode;
    var current_key = String.fromCharCode(code);
    if(current_key == ml_keyrecorder.q_char) ml_keyrecorder.q_down = true;
    else if(current_key == ml_keyrecorder.e_char) ml_keyrecorder.e_down = true;
    else if(current_key == ml_keyrecorder.z_char) ml_keyrecorder.z_down = true;
  },
  clear_key: function(event)
  {
    ml_keyrecorder.set_vars();
    var code = event.charCode || event.keyCode;
    var current_key = String.fromCharCode(code);
    if(current_key == ml_keyrecorder.q_char) ml_keyrecorder.q_down = false;
    else if(current_key == ml_keyrecorder.e_char) ml_keyrecorder.e_down = false;
    else if(current_key == ml_keyrecorder.z_char) ml_keyrecorder.z_down = false;
  }
};

// window.addEventListener("click", ml_tsort.set_vars, false);
// window.addEventListener("load", ml_tsort.init, false);
// window.addEventListener("keydown", ml_keyrecorder.set_key, false);
// window.addEventListener("keyup", ml_keyrecorder.clear_key, false);
// above doesn't work in FF3 due to a FF bug

window.addEventListener("load", 
  function () 
  {
    gBrowser.addEventListener("click", ml_tsort.set_vars, false);
    gBrowser.addEventListener("load", ml_tsort.init, false);
    gBrowser.addEventListener("keydown", ml_keyrecorder.set_key, false);
    gBrowser.addEventListener("keyup", ml_keyrecorder.clear_key, false);
  },
  false
);
